#!/bin/bash
# Automate Jboss install script: v. 0.5
# Written by: Georgi Dimitrov Georgiev - gdgeorgiev@hpe.com
# Completion date: 03.02.2016
# !! Use at your own risk !!

##domain=$1
##java_version=$2
##tomcat_version=$3
##http=$4
##ajp=$5
##sdport=$6

# Define tomcat http port, ajp port, shutdown port and Proxy Url vars
http='10080';
ajp='11010';
sdport='21080'
proxy_url='http-proxy-ha.e-ssi.net:8080';
export https_proxy="$proxy_url"
# webdav host and dir - sl04097:/webdienste/dav/eoi/software # 
# Set scripts URL
scripts_url='https://webdav.intranet.eon-it.com/eoi/software/scripts';

# sl04562 - nordic jboss prod
# Define download jboss_url
jboss_url='https://webdav.intranet.eon-it.com/eoi/software/jboss';
jboss[0]="jboss-3.2.8.SP1.tar.gz";
jboss[1]="jboss-4.2.3.GA.tar.gz";
jboss[2]="jboss-5.1.0.GA.tar.gz";
jboss[3]="jboss-6.1.0.Final.tar.gz";
jboss[4]="jboss-as-7.1.1.Final.tar.gz";

# Define java download url
java_url='https://webdav.intranet.eon-it.com/eoi/software/java';
java[0]="jdk-7u79-linux-i586.tar.gz";
java[1]="jdk-7u79-linux-x64.tar.gz";
java[2]="jdk-8u71-linux-i586.tar.gz";
java[3]="jdk-8u71-linux-x64.tar.gz";
tomcat_cnt=${#tomcat[@]};
jboss_cnt=${#jboss[@]};
java_cnt=${#java[@]};


# Enumerate jboss, java array count
java_path='/webdienste/java/jdk';
temp_path='/webdienste/transfer/autoinstall';
jboss_path='/webdienste/appserv-ejb/jboss';


###check_basic_args () {
###if [ "$#" -lt "5" ]; then
###echo "$0: not enough arguments.";
###echo "Usage: fqdn java_version tomcat_version http_port ajp_port shutdown_port. Http and ajp are required."
###exit 2
###fi
###}


# Get domain and ip_address args
get_args () {
read -p "Domain: " domain;
read -p "IP Address: " ip_address;
if [[ "$domain" == '' ]] || [[ "$ip_address" == '' ]]; then
echo 'Missing or improper domain or IP address argument';
get_args;
fi

}

# Choose Jboss / Java version
choose_version () { 
# Choose Jboss version
##echo 'Choose Tomcat Version: ';
for i in $(seq 0 $(($jboss_cnt - 1))); do
echo "$i. ${jboss[$i]}";
done
read -p "Choose Tomcat version:" jboss_version;
echo "$jboss_version";

if [[ $jboss_version -ne "1" ]] && [[ $jboss_version -ne "2" ]] && [[ $jboss_version -ne "3" ]] && [[ $jboss_version -ne "4" ]] && [[ $jboss_version -ne "5" ]]; then
echo "Version doesnt exist";
exit 0;
fi
jboss_dir="$(echo ${jboss[$jboss_version]} | sed -e "s#.tar.gz##g")";
###echo "|Tomcat_Dir: $jboss_dir|";
##exit 0;

# Choose java version
##echo 'Choose Java Version';
for i in $(seq 0 $(($java_cnt - 1))); do
echo "$i. ${java[$i]}";
done
read -p "Choose Java version:" java_version;
echo "$java_version";

if [[ $java_version -ne "1" ]] && [[ $java_version -ne "2" ]] && [[ $java_version -ne "3" ]] && [[ $java_version -ne "3" ]] && [[ $java_version -ne "4" ]]; then
echo "Version doesnt exist";
exit 0;
fi

java_dir="$(echo ${java[$java_version]} | sed -e "s#.tar.gz##g")";

##exit 0;


}

#Download Jboss

down_jboss () {
if [ -d $temp_path ]; then
    cd $temp_path
    wget --no-check-certificate --timeout=5 $jboss_url/${jboss[$jboss_version]}
    tar zxvf ${jboss[$jboss_version]}
else
mkdir $temp_path
    cd $temp_path
    wget --no-check-certificate --timeout=5 $jboss_url/${jboss[$jboss_version]}
    tar zxvf ${jboss[$jboss_version]}
fi


#Jboss create dirs
if [[ ! -d "$jboss_path/$domain" ]]; then
mkdir -p $jboss_path/${domain}
   cd $temp_path/$jboss_dir/
else
echo "JBoss dir $jboss_path/$domain, existing, will not continue";
exit 1;
fi

##   wget --no-check-certificate --timeout=5 $jboss_url/lib.tar.gz
##   echo "Extracting libs";
##   tar -zxvvf lib.tar.gz

# Disable unusued webapps
###read -p 'Disable common default webapps {balancer,jsp-examples,servlets-examples,tomcat-docs,webdav} [Y/N]:' disable
###if [[ "$disable" == 'y' ]] || [[ "$disable" == 'Y' ]]; then
###echo 'Removing Read / Write / Exec access from {balancer,jsp-examples,servlets-examples,tomcat-docs,webdav,examples,host-manager,manager}';
###chmod 000 -R $temp_path/$jboss_dir/webapps/{balancer,jsp-examples,servlets-examples,tomcat-docs,webdav,examples,host-manager,manager,docs} 2>&1 >/dev/null
###fi

cp -rpf $temp_path/$jboss_dir/ $jboss_path/${domain}/
cd $jboss_path/${domain}/

# Create current symlink to $jboss_path/${domain}/latest_version
if [[ ! -L $jboss_path/$domain/current ]]; then
ln -sf $(ls -1|uniq) current
fi


###    cd $jboss_path/${domain}/current/bin/
###echo "Downloading with wget setenv.sh";
###  wget --no-check-certificate --timeout=5 $scripts_url/setenv.sh
###  chmod +x $jboss_path/${domain}/current/bin/setenv.sh
##	cd /etc/init.d/
##	wget --no-check-certificate --timeout=5 $scripts_url/

}

#Java create dirs

down_java () {

# get java dir var
java_dir="$(echo ${java[$version]} | sed -e "s#.tar.gz##g")";

# check whether temp_path exists and download java
if [ -d $temp_path ]; then
    cd $temp_path
    wget --no-check-certificate --timeout=5 $java_url/${java[$java_version]}
    tar zxvf ${java[$java_version]}
else
    mkdir -p $temp_path
    cd $temp_path
    wget --no-check-certificate --timeout=5 $java_url/${java[$java_version]}
    tar zxvf ${java[$java_version]}

fi


#Java create dir
if [[ ! -d "$jboss_path/$domain" ]]; then
mkdir -p $java_path/${domain}/

cp -rpf $temp_path/jdk*/ /webdienste/java/jdk/${domain}/
cd $java_path/${domain}/

else
echo "Java dir $java_path/$domain existing, exiting ..";
exit 1;

fi

# Create current symlink to java installed latest version
if [[ ! -L $java_path/$domain/current ]]; then
ln -sf $(ls -1|uniq) current
fi

cd $java_path/${domain}/current/bin/

}


fix_settings () {
##echo "${!jboss[@]}"
##exit 1;
if [[ $jboss_version -eq '0' ]]; then
echo "Manually fix configuration";
fi

if [[ $jboss_version -eq '1' ]]; then
echo "Edit manually /webdienste/appserv-ejb/jboss/<FQDN>/current/server/<Configuration>/deploy";

fi

if [[ $jboss_version -eq '2' ]]; then
cd /etc/init.d
wget --no-check-certificate --timeout=5 $jboss_url/jboss-5.0.0-ga.sh
mv jboss-5.0.0-ga.sh jboss_$domain
chmod +x jboss_$domain
sed -i "s/site_url.com/${domain}/" $jboss_path/${domain}/current/bin/jboss_$domain

fi


if [[ $jboss_version -eq '3' ]]; then
cd /etc/init.d
wget $scripts_url/jboss-6.0.0-ga.sh
mv jboss-6.0.0-ga.sh jboss.sh_$domain
chmod +x jboss_$domain
sed -i "s/site_url.com/${domain}/" $jboss_path/${domain}/current/bin/jboss_$domain
cd $jboss_path/$domain/current/bin
mv run.conf run.conf.orig
wget --no-check-certificate --timeout=5 $scripts_url/run.conf
sed -i "s/1.2.3.4/$ip_address/g" $jboss_path/${domain}/current/bin/run.conf
sed -i "s/site-url.com/$domain/g" $jboss_path/${domain}/current/bin/run.conf
sed -i "s#\${jboss.web.ajp.port}#$ajp#g" $jboss_path/$domain/current/server/default/deploy/jbossweb.sar/server.xml
echo "Edit manually  $jboss_path/$domain/current/server/default/deploy/jbossweb.sar/server.xml";
## uncomment if address set doesn't work
##sed -i "s/${jboss.bind.address}/$ip_address/g" $jboss_path/$domain/current/server/default/deploy/jbossweb.sar/server.xml
fi

if [[ "${!jboss[@]}" == '4' ]]; then
wget --no-check-certificate --timeout=5 $scripts_url/jboss-7.sh
mv jboss-6.sh jboss_$domain
chmod +x jboss_"$domain"
sed -i "s/site_url.com/${domain}/g" $jboss_path/${domain}/current/bin/jboss_"$domain"
##sed -i "s/</virtual-server>/</virtual-server>\n/g" $jboss_path/$domain/current/standalone/configuration/standalone.xml
echo 'For JBoss 7: in standalone/configuration/standalone.xml (virtual-server name must be default-host)';
echo        '<subsystem xmlns="urn:jboss:domain:web:1.0" default-virtual-server="default-host">';
echo             '<connector name="ajp" protocol="AJP/1.3" socket-binding="ajp" scheme="ajp"/>';
echo            '<!-- <connector name="http" scheme="http" protocol="HTTP/1.1" socket-binding="http"/> -->';
echo            '<virtual-server name="default-host" enable-welcome-root="false">';
echo            '...';
echo            '</virtual-server>';
echo        '</subsystem>    <socket-binding-group name="standard-sockets" default-interface="public">';
echo       '...';
echo        '<socket-binding name="http" port="11001"/>';
echo        '<socket-binding name="ajp" port="11002"/>';
echo    '</socket-binding-group>';

fi

#Change jboss settings
##echo '------------------------------------------------';
##echo "Changing |setenv.sh| and |server.xml| Configurations ."
##sed -i "s/site_url.com/${domain}/" $jboss_path/${domain}/current/bin/setenv.sh
##sed -i "s/8009/${ajp}/" $jboss_path/${domain}/current/conf/server.xml
##sed -i "s/protocol=\"AJP\/1.3\"/protocol=\"AJP\/1.3\" address=\"${ip_address}\"/g" $jboss_path/${domain}/current/conf/server.xml
##sed -i "s/8005/${sdport}/" $jboss_path/${domain}/current/conf/server.xml
##sed -i "s/site-url.com/${domain}/g" $jboss_path/${domain}/current/bin/setenv.sh
if [[ $(grep "${domain}" $jboss_path/.activ_instances.lst 2>&1 >/dev/null) ]]; then 
echo "Will not add $domain to .active_instances.lst .. Existing."; 
else
echo "Adding $domain to $jboss_path/.activ_instances.lst";
echo "$domain jboss_$domain default" >> $jboss_path/.activ_instances.lst
fi

}

startup () {
cd $jboss_path/${domain}/current/bin
echo '--------------------------------';
echo "Starting up Tomcat for ${domain}";
sh standalone.sh
echo "Sleeping 10 seconds";
sleep 10;
##echo "Catalina.out messages";

##if [ -f $jboss_path/${domain}/current/logs/catalina.out ]; then
##tail -n 50 $jboss_path/${domain}/current/logs/catalina.out
##else
##echo "catalina.out not found .. exiting";
##exit 1;
##fi

}


cleanup () {
echo "Cleaning up everything in $temp_path";
rm -rf $temp_path/*
##echo "---------------------------------------------------";
##echo "If you need to enable some external libraries get them from: $tomcat_path/libs.tar.gz";
##echo '';
##echo "cd $temp_path/";
##echo "E.g. wget $jboss_url/libs.tar.gz";
##echo "N.B. ! Extracting all libs.tar.gz straight to $tomcat_path/$domain/current will crash Tomcat !"; 
##echo '';
}

main () {
##check_basic_args;
get_args;
choose_version;
down_jboss;
down_java;
fix_settings;
startup;
cleanup;
}
main;
